unit cubes1;

{$mode objfpc}{$H+}

interface

uses
   Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
	 Spin, BGRABitmap, BGRABitmapTypes, math;

type

	 { TForm1 }

   TForm1 = class(TForm)
			Button1: TButton;
			Button2: TButton;
			Image1: TImage;
			Label1: TLabel;
			Label2: TLabel;
			Label3: TLabel;
			SpX: TSpinEdit;
			SpY: TSpinEdit;
			SpZ: TSpinEdit;
      Procedure CubeStuff;
      procedure drawCube;
			procedure Button1Click(Sender: TObject);
			procedure Button2Click(Sender: TObject);
   private

   public

   end;

var
   Form1: TForm1;

implementation
{$R *.lfm}


const
Deg2Rad = pi/180;
Rad2Deg = 180/pi;
offy = 200;
offx = 50;
Cubelen=100;

var
array3D : array of TPoint3D;
array2D : ArrayOfTPointF;

procedure incF (var i : single; increment: single); inline;
begin
i := i + increment;
end;



// ________________3D with Good Old Euler____________________________________________________


// angles in degrees
procedure RotatePoint3D (Var P : TPoint3D; angX,angY,angZ : single);inline;
var tmpX, tmpY, tmpZ : single;
    sinus, cosinus : single;
    ax,aY,aZ : single;
begin
aX := angX * Deg2Rad;
aY := angY * Deg2Rad;
aZ := angZ * Deg2Rad;
// X-Achse
math.sincos(aX,sinus, cosinus);
tmpY := P.y * cosinus - P.z * sinus;
tmpZ := P.y * sinus + P.z * cosinus;
P.y := tmpY;
P.z := tmpZ;

// Y-Achse
math.sincos(aY,sinus, cosinus);
tmpX := P.x * cosinus - P.z * sinus;
tmpZ := P.x * sinus + P.z * cosinus;
P.x := tmpX;
P.z := tmpZ;

// Z-Achse
math.sincos(aZ,sinus, cosinus);
tmpX := P.x * cosinus - P.y * sinus;
tmpY := P.x * sinus + P.y * cosinus;
P.x := tmpX;
P.y := tmpY;
end;


// for 3 cubes we need 4 planes with the same x
procedure initCubes;
var i : integer;
    x : single;
begin
setLength (array3D,4*4);
array3D[0] := Point3D(0,1,-1); // top front
array3D[1] := Point3D(0,1, 1); // back Top
array3D[2] := Point3D (0,-1, 1); // back bottom
array3D[3] := Point3D (0,-1, -1);  //
for i := 4 to high (array3D) do
  begin
  x := i div 4 * 2;
  array3D[i] := array3D[i-4];
  array3D[i].x := x;
	end;
end; // initcubes


procedure ResizeMoveCube;
var i : integer;
begin
for i := 0 to high (array3d) do
  begin
  array3d[i].Scale(Cubelen);
  incF(array3d[i].x,offx);
  incF(array3d[i].y,offy);
	end;
end;

procedure RotateCube (angX, angY, AngZ : single);
var i : integer;
begin
for i := 0 to high (array3d) do
  begin
  RotatePoint3D(array3d[i],angX,angY,angZ);
	end;
end;

procedure Cube3d2d;
var i : integer;
begin
Setlength(array2D, Length(array3D));
for i := 0 to  high (array2D) do
  begin
  array2d[i].x := array3d[i].x;
  array2d[i].y := array3d[i].y;
	end;
end;

function Midp (p1,p2: TPointF) : TPointF;
begin
with result do
  begin
  x := (p2.x - p1.x) /2 + p1.x;
  y := (p2.y - p1.y) /2 + p1.y;
	end;

end;

{ TForm1 }

procedure TForm1.drawCube;
var bmp : TBGRABitmap;
    i,k,m : integer;
    col,TranspGrey: TBGRApixel;


    procedure plane (no: integer);
    var pl : array[0..3] of TPointF;
        k : integer;
        col : TBGRAPixel;
    begin
    case no of
    0: col:= cssred;
    1: col:= cssLime;
    2: col:= cssBlue;
    end;
    col.alpha := 127;
    k := no* 4;
    pl[0] := Midp(array2D[k], array2d[k+1]);
    pl[1] := Midp(array2d[k+2],array2d[k+3]);
    pl[2] := Midp(array2d[k+2+4],array2d[k+3+4]);
    pl[3] := Midp(array2D[k+4], array2d[k+1+4]);
    bmp.DrawPolygonAntialias(pl,cssBlack,1,col);
		end;

begin
bmp := TBGRAbitmap.create (Image1.width, Image1.Height,cssWhite);
TranspGrey := BGRA(127,127,127,127);
for k := 0 to 3 do
   begin
   m := k* 4;
   //showMessage ('m= '+IntToStr(m));
   bmp.DrawPolygonAntialias(PointsF( [array2d[m],array2d[m+1], array2d[m+2],
                            array2d[m+3] ]),cssBlack,1,TranspGrey);
   if k < 3 then
   begin
   for i := 0 to 3 do
     begin
     case i of
     0: col := cssRed;
     1: col := csslime;
     2: col := cssAQua;
     3: col := cssBlack;
     end; //case
     bmp.DrawLineAntialias(array2d[m+i].x, array2d[m+i].y, array2d[m+i+4].x,
     array2d[m+i+4].y,col,1);
     if i = 3 then plane (k);
		 end;
   end;

   // Trennwand
	 end;
  bmp.draw(Image1.canvas,0,0,true);
  bmp.free;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   close;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   CubeStuff;
   drawCube;
end;

Procedure TForm1.CubeStuff;
begin
initCubes;
ResizeMoveCube;
RotateCube(SPx.Value, SPy.value,spZ.value);
Cube3d2d;
end;



end.

